#include "HLM.h"
#include <AppKit.h>
#include <String.h>
#include <stdio.h>


HLM::HLM() {
	BFile		*file;
	entry_ref	ref;
	app_info	ai;
	size_t		size;
	
	be_app->GetAppInfo(&ai);
	file=new BFile(&ai.ref, B_READ_ONLY);
	res=new BResources(file);
	msg=new BMessage();
	delete file;
	

	// get language names available
	for (int32 i='HLMg'; i<'HLMg'+50; i++) {
		if (LanguageAt(i)) {
			size_t	size;
			const char *name;
			//LoadLanguage(i);
			res->GetResourceInfo((type_code)B_MESSAGE_TYPE, i, &name, &size);
			languages[i-'HLMg']=strdup(name);
		} else
			languages[i-'HLMg']=strdup("");
	}
}

HLM::~HLM() {
	delete msg;
	delete res;
}

const char *HLM::L(const char *name) {
	BString		label;
	
	if (msg->FindString(name, &label)==B_OK) {
		return strdup(label.String());
	} else {
		return "<no string>";
	}
}

bool	HLM::LanguageAt(int32 id) {
	return res->HasResource(B_MESSAGE_TYPE, id);
}

const char 	*HLM::LanguageName(int32 id) {
	size_t size;
	void *name;
	
	return languages[id-'HLMg'].String();
}

int32	HLM::GetLIDByName(const char *name) {
	for (int32 i='HLMg'; i<'HLMg'+50; i++) {
		if (languages[i-'HLMg'].Compare(name)==0) {
			return i;
		}
	}
	return -1;
}

void	HLM::LoadLanguage(int32 id) {
	size_t	size;
	const void	*data;
	
	size=0;
	data=res->LoadResource(B_MESSAGE_TYPE, id, &size);
	msg->MakeEmpty();
	msg->Unflatten((const char *)data);
}
